// root macro

//void showControlPlots()
{
    gStyle->SetPalette(1) ;

    TFile f("TimePixControlPlots.root");
    
    TCanvas c1("TimePixControlPlots","TimePixControlPlots",0,0,1680,1000);

    c1.Divide(4,3);
    f.cd("MyXYZDistributionTracksProcessor");

    c1.cd(1);
    xDistributionTracksHisto->Draw();
    xDistributionTracksHisto->SetXTitle("x [mm]");
    xDistributionTracksHisto->SetYTitle("Entries");

    c1.cd(2);
    yDistributionTracksHisto->Draw();
    yDistributionTracksHisto->SetXTitle("y [mm]");
    yDistributionTracksHisto->SetYTitle("Entries");

    c1.cd(3);
    zDistributionTracksHisto->Draw();
    zDistributionTracksHisto->SetXTitle("x [mm]");
    zDistributionTracksHisto->SetYTitle("Entries");

    f.cd("MyTrackParametersDistributionProcessor");

    c1.cd(4);
    phiDistributionHisto->Draw();
    phiDistributionHisto->SetXTitle("#phi [rad]");
    phiDistributionHisto->SetYTitle("Entries");

    c1.cd(5);
    lambdaDistributionHisto->Draw();
    lambdaDistributionHisto->SetXTitle("#lambda [rad]");
    lambdaDistributionHisto->SetYTitle("Entries");

    f.cd("MyTimePixRawOccupancyProcessor");
	
    c1.cd(6);
    TimePix_occupancy_TimePixZeroSuppressedData_chip0->Draw("colz");
    TimePix_occupancy_TimePixZeroSuppressedData_chip0->SetXTitle("Pixel");
    TimePix_occupancy_TimePixZeroSuppressedData_chip0->SetYTitle("Pixel");

    f.cd("MyHitAndTrackCounterProcessor");

    c1.cd(7);
    hitsPerEventHisto->Draw();
    hitsPerEventHisto->SetXTitle("NHits per Event / Track");
    hitsPerEventHisto->SetYTitle("Entries");
    hitsPerTrackHisto->SetLineColor(kRed);
    hitsPerTrackHisto->SetLabelColor(kRed);
    hitsPerTrackHisto->Draw("sames");

    c1.cd(8);
    tracksPerEventHisto->Draw();
    tracksPerEventHisto->SetXTitle("NTracks per Event");
    tracksPerEventHisto->SetYTitle("Entries");

    f.cd("MyHitAndTrackChargeProcessor");

    c1.cd(9);
    ChargePerHit->Draw();
    ChargePerHit->SetXTitle("Charge Hit [ADC Counts]");
    ChargePerHit->SetYTitle("Entries");

    c1.cd(10);
    ChargePerHitOnTrack->Draw();
    ChargePerHitOnTrack->SetXTitle("Charge per Hit [ADC Counts]");
    ChargePerHitOnTrack->SetYTitle("Entries");

    c1.cd(11);
    ChargePerTrack->Draw();
    ChargePerTrack->SetXTitle("Charge per Track [ADC Counts]");
    ChargePerTrack->SetYTitle("Entries");

    c1.cd(12);
    dEdx->Draw();
    dEdx->SetXTitle("Charge per Track Length (dE/dx) [ADC Counts]");
    dEdx->SetYTitle("Entries");
}
